/**
 * @author minimus
 * @copyright 2009 - 2011
 * @version 1.0.15
 */
 
(function($) {
  scOptions.delta = parseInt(scOptions.delta);
  
	var opts = {};
	var fbSubUrl = '';
	var twFolUrl = '';
	var fbCount = '0';
	var twCount = '0';
	var winWidth;
	var winHeight;
	var canvas = null;
  var buttonCanvas = {
    feedBurner: null,
    twitter: null
  }
	var fbImg;
	var twImg;
  
	fbImg = new Image();
	fbImg.onload = function() {
		if(null != buttonCanvas.feedBurner) 
			doDrawButtonImg(buttonCanvas.feedBurner, this); 
		return false;
	}
	fbImg.src = scOptions.feedBurner.imgUrl;
	twImg = new Image();
	twImg.onload = function() {
		if(null != buttonCanvas.twitter)
			doDrawButtonImg(buttonCanvas.twitter, this); 
		return false;
	}
	twImg.src = scOptions.twitter.imgUrl;
	
  function scGetRGB(color) {
		var clr = color.replace('#', '');
		var r = parseInt('0x'+clr.slice(0,2));
		var g = parseInt('0x'+clr.slice(2,4));
		var b = parseInt('0x'+clr.slice(4,6));
		return r.toString()+','+g.toString()+','+b.toString();
	}
  
  function doDrawButtonImg(ctx, img) {
    if (!$.browser.safari && !$.browser.mozilla)
      ctx.drawImage(img, 2,  2, 50, 50);
    else {
      if (img.complete) ctx.drawImage(img, 2, 2, 50, 50);
    }
  }
  
  function doDrawButton(ctx, width, img, count, str) {
    doDrawButtonImg(ctx, img);
    ctx.textAlign = 'center';
    ctx.textBaseline = 'middle';
    ctx.fillStyle = opts.fontColor;
    ctx.font = 'bold 15px Arial';
    if($.browser.safari) {
      fontSize = 15;
      textWidth = ctx.measureText(count).width;
      if(textWidth > width - 6) {
        fontSize = Math.floor(fontSize * ((width - 6)/textWidth));
        ctx.font = 'bold ' + fontSize + 'px Arial';
      }
      ctx.fillText(count, width/2, 63);
    }
    else ctx.fillText(count, width/2, 63, width - 6);

    ctx.font = 'bold 10px Arial';
    if($.browser.safari) {
      fontSize = 10;
      textWidth = ctx.measureText(str).width;
      if(textWidth > /*rect.*/width - 6) {
        fontSize = Math.floor(fontSize * ((width - 6)/textWidth));
        ctx.font = 'bold ' + fontSize + 'px Arial';
      }
      ctx.fillText(str, width/2, 77);
    }
    else ctx.fillText(str, width/2, 77, width - 6);
  }
	
	function doDraw(cvs) {
		if (null == cvs) return;    		
		var cw = cvs.width;
		var ch = cvs.height;
		var ctx = cvs.getContext("2d");
		if (opts.position == 'right') {
			ctx.clearRect(0, 0, cw, ch);
			var brd = 'rgba(' + scGetRGB(opts.borderColor) + ', 0.4)';
			ctx.beginPath();
			ctx.moveTo(cw, 0);
			ctx.lineTo(12, 0);
			ctx.quadraticCurveTo(0, 0, 0, 12);
			ctx.lineTo(0, ch - 12);
			ctx.quadraticCurveTo(0, ch, 12, ch);
			ctx.lineTo(cw, ch);
			ctx.closePath();
			ctx.fillStyle = brd;
			ctx.fill();
      
      // Windows 7 Style      
      if(opts.borderStyle == 'win7') {
        ctx.strokeStyle = 'rgba(255,255,255,0.4)';
        ctx.stroke();
      
        var winGrd = null;
        //winGrd = ctx.createLinearGradient(0, ch/3, 0, 0);
        winGrd = ctx.createRadialGradient(0, ch/3, 0, 0, ch/3, ch/4);
        winGrd.addColorStop(0, 'rgba(255,255,255,0.5)');
        winGrd.addColorStop(1, 'rgba(255,255,255,0.1)');
        ctx.beginPath();
        ctx.moveTo(cw, 0);
        ctx.lineTo(12, 0);
        ctx.quadraticCurveTo(0, 0, 0, 12);
        ctx.lineTo(0, ch/3);
        ctx.lineTo(cw, ch/3);
        ctx.closePath();
        ctx.fillStyle = winGrd;
        ctx.fill();
      
        ctx.beginPath();
        ctx.moveTo(11, 11);
        ctx.lineTo(11, ch - 11);
        ctx.lineTo(cw, ch - 11);
        ctx.lineTo(cw, 11);
        ctx.closePath();
        ctx.strokeStyle = 'rgba(225, 225, 225, 0.1)';
        ctx.stroke();
      }
      // end of Windows 7 Style
			
			ctx.fillStyle	= 'rgba(255,255,255,1)';
			ctx.fillRect(12, 12, cw-12, ch-24)
		
			var gradient = null;
			if (opts.dgv == 'horizontal') 
				gradient = ctx.createLinearGradient(12, 12, cw, 12);
			else 
				gradient = ctx.createLinearGradient(12, 12, 12, ch);
			gradient.addColorStop(0, opts.color);
			gradient.addColorStop(0.4, opts.color);
			gradient.addColorStop(1, opts.colorTo);
			ctx.beginPath();
			ctx.moveTo(12, 12);
			ctx.lineTo(12, ch - 12);
			ctx.lineTo(cw, ch - 12);
			ctx.lineTo(cw, 12);
			ctx.closePath();
			ctx.fillStyle = gradient;
			ctx.fill();
      
      // Windows 7 Style
      if(opts.borderStyle == 'win7') {
        ctx.strokeStyle = 'rgba(102, 107, 114, 1)';
        ctx.stroke();
      }      
      // end of Windows 7 Style
		}
		else {
			ctx.clearRect(0, 0, cw, ch);
			var brd = 'rgba(' + scGetRGB(opts.borderColor) + ', 0.4)';
			ctx.beginPath();
			ctx.moveTo(0, 0);
			ctx.lineTo(cw - 12, 0);
			ctx.quadraticCurveTo(cw, 0, cw, 12);
			ctx.lineTo(cw, ch - 12);
			ctx.quadraticCurveTo(cw, ch, cw-12, ch);
			ctx.lineTo(0, ch);
			ctx.closePath();
			ctx.fillStyle = brd;
			ctx.fill();
      
      // Windows 7 Style      
      if(opts.borderStyle == 'win7') {
        ctx.strokeStyle = 'rgba(255,255,255,0.4)';
        ctx.stroke();
      
        var winGrd = null;
        //winGrd = ctx.createLinearGradient(0, ch/3, 0, 0);
        winGrd = ctx.createRadialGradient(cw, ch/3, 0, cw, ch/3, ch/4);
        winGrd.addColorStop(0, 'rgba(255,255,255,0.5)');
        winGrd.addColorStop(1, 'rgba(255,255,255,0.1)');
        ctx.beginPath();
        ctx.moveTo(0, 0);
        ctx.lineTo(cw - 12, 0);
        ctx.quadraticCurveTo(cw, 0, cw, 12);
        ctx.lineTo(cw, ch/3);
        ctx.lineTo(0, ch/3);
        ctx.closePath();
        ctx.fillStyle = winGrd;
        ctx.fill();
      
        ctx.beginPath();
        ctx.moveTo(0, 11);
        ctx.lineTo(cw - 11, 11);
        ctx.lineTo(cw - 11, ch - 11);
        ctx.lineTo(0, ch - 11);
        ctx.closePath();
        ctx.strokeStyle = 'rgba(225, 225, 225, 0.1)';
        ctx.stroke();
      }
      // end of Windows 7 Style
			
			ctx.fillStyle	= 'rgba(255,255,255,1)';
		
			var gradient = null;
			if (opts.dgv == 'horizontal') 
				gradient = ctx.createLinearGradient(0, 12, cw - 12, 12);
			else 
				gradient = ctx.createLinearGradient(0, 12, 0, ch - 12);
			gradient.addColorStop(0, opts.color);
			gradient.addColorStop(0.4, opts.color);
			gradient.addColorStop(1, opts.colorTo);
			ctx.beginPath();
			ctx.moveTo(0, 12);
			ctx.lineTo(0, ch - 12);
			ctx.lineTo(cw - 12, ch - 12);
			ctx.lineTo(cw - 12, 12);
			ctx.closePath();
			ctx.fillStyle = gradient;
			ctx.fill();
		}
	}
	
	function doButton(name, count, url, img, hintImg, str, hint, index) {
    var btnTop = 88*index + 12;
    if(window.G_vmlCanvasManager) {
      $("#scdiv").append('<div id="' + name + '-button" width="52" height="88"></div>');
      cvs = G_vmlCanvasManager.initElement($('#'+name+'-button').get(0));
    }
    else {
      $("#scdiv").append('<canvas id="' + name + '-button" width="52" height="88"></canvas>');
      cvs = $('#'+name+'-button').get(0);
    }
    $("#"+name+"-button").css({
      position: 'absolute',
      top: btnTop + 'px',
      left: ((opts.position == 'right') ? '12px' : '0px'),
      'min-width': '51px',
      'min-height': '87px',
      cursor: 'pointer',
      'z-index': 3
    }).click(function(){
      window.open(url, 'SubNew');
    });
    if(opts.hints == 'standard') $("#"+name+"-button").attr({title: hint});
    else 
      $("#"+name+"-button").qtip({
        id: name + 'Tip',
        prerender: true,
        content: { 
          text: '<img src="'+ hintImg +'" height="40" width="40" style="float:left; margin-right:5px" />' + hint
        },
        style: {
          classes: opts.hintStyle
        }, 
        position: {
          my: ((opts.position == 'left')? 'left center' : 'right center'),
          at: ((opts.position == 'left')? 'right center' : 'left center'),
          target: $("#"+name+"-button"),
          adjust: { 
            x: ((opts.position == 'left') ? 13 : -13), 
            y: 0 
          }
        }
      });
      
    var cw = cvs.width;
    var ch = cvs.height;
    var ctx = cvs.getContext("2d");
    switch(name) {
      case 'feedburner': 
        buttonCanvas.feedBurner = ctx;
        break;
      case 'twitter':
        buttonCanvas.twitter = ctx;
        break;
    }
    doDrawButton(ctx, cw, img, count, str);
  }
	
	$(document).ready(function($){		   
    if((typeof(scUserOptions) != 'undefined') && (null != scUserOptions)) $.extend(true, opts, scOptions, scUserOptions);
		else opts = scOptions;
		fbUrl = 'http://pipes.yahoo.com/pipes/pipe.run';
		twUrl = 'http://twitter.com/users/show.json';
		fbSubUrl = 'http://feeds.feedburner.com/' + opts.feedBurner.id + ((opts.feedBurner.subData == 'xml') ? '?format=xml' : '');
		twFolUrl = 'http://twitter.com/' + opts.twitter.id;
		var scDiv = document.createElement("div");
		scDiv.id = "scdiv";
		document.body.appendChild(scDiv);
		
		if( typeof( window.innerHeight ) == 'number' ) winHeight = window.innerHeight;
  	else if( document.documentElement && document.documentElement.clientHeight ) winHeight = document.documentElement.clientHeight;
  	else if( document.body && document.body.clientHeight ) winHeight = document.body.clientHeight;
		
		var dt = Math.floor(winHeight/2-100) + opts.delta;
		
		if(opts.position == 'right') $("#scdiv").css({right: '0px'});
		else $("#scdiv").css({left: '0px'});
			
		$("#scdiv").css({
			position: 'fixed', 
			top: ((dt < 0) ? 0 : ((dt > winHeight-200) ? winHeight-200 : dt)),
			background: "transparent", 
			height: 200, 
			width: 65
		});
		if (window.G_vmlCanvasManager) {
      $("#scdiv").append('<div id="sc-canvas" width="65" height="200" style="position:absolute; top:0px; left:0px;"></div>');
      canvas = G_vmlCanvasManager.initElement($("#sc-canvas").get(0));
    } else {
      $("#scdiv").append('<canvas id="sc-canvas" width="65" height="200" style="position:absolute; top:0px; left:0px;"></canvas>');
      canvas = $("#sc-canvas").get(0);
    }
    doDraw(canvas);
    
		if (opts.feedBurner.count == '-1') {
			$.getJSON(fbUrl + '?_id=b47b5cb1a615935b43858618ebe5ee32&uri=' + opts.feedBurner.id + '&_render=json&_callback=?', 
				function(data){
					fbCount = data.value.items[0].circulation;
          doButton('feedburner', fbCount, fbSubUrl, fbImg, opts.feedBurner.hintImg, opts.feedBurner.str, opts.feedBurner.hint, 0);
				}
			);
		}
		else {
      fbCount = opts.feedBurner.count;
      doButton('feedburner', fbCount, fbSubUrl, fbImg, opts.feedBurner.hintImg, opts.feedBurner.str, opts.feedBurner.hint, 0);
    }
		if(opts.twitter.count == '-1') {
			$.ajax({
				type: 'GET',
				url: twUrl,
				data: {'screen_name': opts.twitter.id},
				dataType: 'jsonp',
				success: function(jsonData) {
					twCount = jsonData.followers_count;
					if(opts.twitter.useAvatar) opts.twitter.hintImg = jsonData.profile_image_url;
          doButton('twitter', twCount, twFolUrl, twImg, opts.twitter.hintImg, opts.twitter.str, opts.twitter.hint, 1);
				}
			});
		}
		else {
      twCount = opts.twitter.count;
      doButton('twitter', twCount, twFolUrl, twImg, opts.twitter.hintImg, opts.twitter.str, opts.twitter.hint, 1);
    }
	});
	
	$(window).resize(function(){
		if( typeof( window.innerHeight ) == 'number' ) winHeight = window.innerHeight;
  	else if( document.documentElement && document.documentElement.clientHeight ) winHeight = document.documentElement.clientHeight;
  	else if( document.body && document.body.clientHeight ) winHeight = document.body.clientHeight;
		var dt = Math.floor(winHeight/2-100) + opts.delta;
		$("#scdiv").css({	top: ((dt < 0) ? 0 : ((dt > winHeight-200) ? winHeight-200 : dt)) }); 
		return false;
	});
})(jQuery);