<?php
if(class_exists('SimpleCounters') && !class_exists('SimpleCountersAdmin')) {
  class SimpleCountersAdmin extends SimpleCounters {
    function __construct() {
      parent::__construct();
        
      add_action('admin_init', array(&$this, 'initSettings'));
      add_action('admin_menu', array(&$this, 'onAdminPage'));
    }      
    
    function doInfo($data, $value = -2) {
      $options = $this->settings;
      if($options['fbCount'] == '' || $options['twCount'] == '') {
        parent::getCounters();
        $options = $this->settings;
      }
      $output = '';
      switch($data) {
        case 'feedburner':
          if($value == -2) $value = $options['fbCount'];
          $output = '<strong>'.__('FeedBurner', SC_DOMAIN).'</strong>: '.$value.'<span style="color:red">'.(($options['fbErrorCode'] !== '') ? '<br/>'.__('Error Code', SC_DOMAIN).': '.$options['fbErrorCode'].(($value === '-1') ? '. '.__('Data request to FeedBurner server will be run on client side.', SC_DOMAIN) : '') : '').'</span>';
          break;
          
        case 'twitter':
          if($value == -2) $value = $options['twCount']; 
          $output = '<strong>'.__('Twitter', SC_DOMAIN).'</strong>: '.$value.'<span style="color:red">'.(($options['twErrorCode'] !== '') ? '<br/>'.__('Error Code', SC_DOMAIN).': '.$options['twErrorCode'].(($value === '-1') ? '. '.__('Data request to Twitter server will be run on client side.', SC_DOMAIN) : '') : '').'</span>';
          break;
      }
      
      return $output;
    }
      
    function adminHeaderStyles() {
      wp_register_style('ColorPickerCSS', WP_PLUGIN_URL.'/simple-counters/css/colorpicker.css');
      wp_enqueue_style('ColorPickerCSS', WP_PLUGIN_URL.'/simple-counters/css/colorpicker.css', false, '1.0');
      wp_enqueue_style('jquery-ui-tabs', WP_PLUGIN_URL.'/simple-counters/css/jquery-ui-1.8.16.custom.css', false, '1.8.16');
      wp_enqueue_style('qtip', WP_PLUGIN_URL.'/simple-counters/css/jquery.qtip.css', false, '2.0.0');
      wp_enqueue_style('scLayout', SC_URL.'css/admin.layout.css', false, SC_VERSION);
      /*echo "<style type='text/css'>\n".
          " .ui-tooltip, .qtip {\n".
          "   max-width: 520px !important;\n". 
          " }\n".
          "#poststuff .inside {\n".
          " font-size: 11px !important;\n".
          "}\n".
          "</style>\n";*/      
    }
    
    function adminHeaderScripts() {
      wp_enqueue_script('jquery');      
      wp_enqueue_script('jquery-ui-core');
      wp_enqueue_script('jquery-ui-tabs');
      wp_enqueue_script('ColorPicker', WP_PLUGIN_URL.'/simple-counters/js/colorpicker.js', array('jquery'), '1.0');
      wp_enqueue_script('qTip', WP_PLUGIN_URL.'/simple-counters/js/jquery.qtip.js', array('jquery'), '2.0.0');
      wp_enqueue_script('AdminLayout', WP_PLUGIN_URL.'/simple-counters/js/sc.admin.js', array('jquery', 'jquery-ui-core', 'jquery-ui-tabs', 'ColorPicker'), SC_VERSION);
    }
    
    function initSettings() {
      //register_setting('scOptions', SC_OPTIONS_NAME);
      add_settings_section('sc_account_section', __('Account Settings', SC_DOMAIN), array(&$this, 'drawAccountSection'), 'simple-counters');
      add_settings_section('sc_output_section', __('Output Data Settings', SC_DOMAIN), array(&$this, 'drawOutputSection'), 'simple-counters');
      add_settings_section('sc_tech_section', __('Technical Settings', SC_DOMAIN), array(&$this, 'drawTechSection'), 'simple-counters');
      add_settings_section('sc_badge_section', __('Badge Settings', SC_DOMAIN), array(&$this, 'drawBadgeSection'), 'simple-counters');
      add_settings_section('sc_hints_section', __('ToolTips Settings', SC_DOMAIN), array(&$this, 'drawHintsSection'), 'simple-counters');
      
      add_settings_field('fbId', __("Define your FeedBurner ID", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_account_section', array('width' => '250px', 'description' => '<span id="feed-uri">'.__("This is the URI of the feed (same as <strong>http://feedproxy.google.com/[feeduri]</strong>). Enter only <strong>[feeduri]</strong>.", SC_DOMAIN).'</span><br/><span id="awareness">'.__('You must enable <strong>Awareness API</strong> in your FeedBurner account (Publicize tab).', SC_DOMAIN).'</span>'));
      add_settings_field('twId', __("Define your Twitter ID", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_account_section', array('width' => '250px', 'description' => __("This is your nick name on Twitter.", SC_DOMAIN)));
      add_settings_field('pluginInfo', __('Your counters values', SC_DOMAIN), array(&$this, 'drawInfo'), 'simple-counters', 'sc_account_section', array("options" => array('feedburner', 'twitter'), 'description' => __('It is result of the last data requests by a server from FeedBurner and Twitter.', SC_DOMAIN)));
      //add_settings_field('fbCount', __('FeedBurner', SC_DOMAIN), array(&$this, 'drawCount'), 'simple-counters', 'sc_account_section', array('count' => 'feedburner'));
      //add_settings_field('twCount', __('Twitter', SC_DOMAIN), array(&$this, 'drawCount'), 'simple-counters', 'sc_account_section', array('count' => 'twitter'));
      
      add_settings_field('fbSubData', __('Define FeedBurner Output Page Data Format', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_output_section', array("options" => array( 'default' => __("Default", SC_DOMAIN), 'xml' => __("RSS XML", SC_DOMAIN)), 'style' => 'vertical', 'description' => __('Selecting "Default" will set output page data format to default FeedBurner Subscription page, selecting "XML" will set output page data format to RSS XML Data Format. In other words, if "Default" when user clicks FeedBurner icon he opens Default FeedBurner Subscription Page, in other case XML RSS Feed.', SC_DOMAIN)));
      
      add_settings_field('requestPeriod', __('Define requests period', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_tech_section', array('style' => 'vertical', "options" => array( 'hourly' => __("Hourly", SC_DOMAIN), 'twicedaily' => __("Twice Daily", SC_DOMAIN), 'daily' => __("Daily", SC_DOMAIN)), 'description' => __('Select requests period for updating FeedBurner and Twitter counters.', SC_DOMAIN)));
      add_settings_field('requestTimeOut', __("Define request timeout", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_tech_section', array('description' => __("This is requests timeout in seconds. In case you have 'Gateway Time-out' request error you can grow this value.", SC_DOMAIN)));
      add_settings_field('errorAction', __('Define action at an answer error', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_tech_section', array('style' => 'vertical', "options" => array( 'error' => __("Error code output (for debug purposes only)", SC_DOMAIN), 'previous' => __("Data output of the last successful request of the data", SC_DOMAIN), 'client' => __("Redirect data request to client side", SC_DOMAIN)), 'description' => __('Define what to do in case a response error happened.', SC_DOMAIN)));
      
      add_settings_field('fontColor', __("Define font color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('description' => __("This is font color of badge (six hex digits).", SC_DOMAIN)));
      add_settings_field('borderColor', __("Define border color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('description' => __("This is semitransparent (40%) color of border (six hex digits).", SC_DOMAIN)));
      add_settings_field('borderStyle', __("Define border style", SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_badge_section', array('options' => array('default' => __('Default', SC_DOMAIN), 'win7' => __('WindowZ Aero', SC_DOMAIN)), 'labelId' => true, 'description' => __("Select border style.", SC_DOMAIN)));
      add_settings_field('color', __("Define start gradient color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('description' => __("This is start color of background gradient (six hex digits).", SC_DOMAIN)));
      add_settings_field('colorTo', __("Define stop gradient color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('description' => __("This is stop color of background gradient (six hex digits).", SC_DOMAIN)));
      add_settings_field('gradient', __('Define gradient vector direction', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_badge_section', array('options' => array( 'vertical' => __("Vertical", SC_DOMAIN), 'horizontal' => __("Horizontal", SC_DOMAIN)), 'description' => __('Selecting "Vertical" will allow drawing gradient from top (start color) to bottom (stop color), "Horizontal" - from left side (start color) to right side (stop color).', SC_DOMAIN)));
      add_settings_field('fbImg', __("Define image for FeedBurner counter", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('width' => '100%', 'description' => __("This is image for FeedBurner badge button (Full URL). 50x50 pixels, transparent background PNG image recommended.", SC_DOMAIN)));
      add_settings_field('twImg', __("Define image for Twitter counter", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('width' => '100%', 'description' => __("This is image for FeedBurner badge button (Full URL). 50x50 pixels, transparent background PNG image recommended.", SC_DOMAIN)));
      add_settings_field('position', __('Define badge position', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_badge_section', array("options" => array( 'right' => __("Right", SC_DOMAIN), 'left' => __("Left", SC_DOMAIN)), 'description' => __('Selecting "Right" will set badge near the right side of browser window, "Left" near the left side.', SC_DOMAIN)));
      add_settings_field('delta', __("Define badge position displacement", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_badge_section', array('description' => __("By default, badge is placed on the middle line of browser window. You can displace badge up (negative value) or down (positive value) relatively middle line by setting this value.", SC_DOMAIN)));
      
      add_settings_field('hintTheme', __("Select Theme", SC_DOMAIN), array(&$this, 'drawSelectOption'), 'simple-counters', 'sc_hints_section', array('options' => array( 'cream' => __('Cream', SC_DOMAIN), 'dark' => __('Dark', SC_DOMAIN), 'green' => __('Green', SC_DOMAIN), 'light' => __('Light', SC_DOMAIN), 'red' => __('Red', SC_DOMAIN), 'blue' => __('Blue', SC_DOMAIN), 'custom' => __('Custom (See below)', SC_DOMAIN)), 'description' => __("Color theme selecting.", SC_DOMAIN)));
      add_settings_field('hintFontColor', __("Define tooltip font color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('description' => __("This is font color of tooltip (six hex digits).", SC_DOMAIN).'<br/>'.__('This parameter is useful only for tooltip custom theme.', SC_DOMAIN)));
      //add_settings_field('hintFontSize', __("Define tooltip font size", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('description' => __("This is font size of tooltip.", SC_DOMAIN)));
      add_settings_field('hintColor', __("Define tooltip background color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('description' => __("This is background color of tooltip (six hex digits).", SC_DOMAIN).'<br/>'.__('This parameter is useful only for tooltip custom theme.', SC_DOMAIN)));
      add_settings_field('hintBorderColor', __("Define tooltip border color", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('description' => __("This is color of tooltip border (six hex digits).", SC_DOMAIN).'<br/>'.__('This parameter is useful only for tooltip custom theme.', SC_DOMAIN)));
      add_settings_field('templStyle', __("Define template-word style", SC_DOMAIN), array(&$this, 'drawCheckGroupOption'), 'simple-counters', 'sc_hints_section', array("options" => array('templBold' => __('bold', SC_DOMAIN), 'templItalic' => __('italic', SC_DOMAIN)), 'description' => __("Select template-words representation style for displaying in the hints.", SC_DOMAIN)));
      add_settings_field('fbHint', __("Define text for FeedBurner counter tooltip", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('width' => '100%', 'description' => __("This is text for FeedBurner tooltip.", SC_DOMAIN).'<br/>'.__("You can use template-word <strong>[blog_name]</strong> to display name of your blog or <strong>[twitter_nick]</strong> to display your Twitter Nickname.", SC_DOMAIN)));
      add_settings_field('fbHintImg', __("Define image for FeedBurner counter tooltip", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('width' => '100%', 'description' => __("This is image for FeedBurner tooltip (Full URL). 40x40 pixels, transparent background PNG image recommended.", SC_DOMAIN)));
      add_settings_field('twHint', __("Define text for Twitter counter tooltip", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('width' => '100%', 'description' => __("This is text for Twitter tooltip.", SC_DOMAIN).'<br/>'.__("You can use template-word <strong>[blog_name]</strong> to display name of your blog or <strong>[twitter_nick]</strong> to display your Twitter Nickname.", SC_DOMAIN)));
      add_settings_field('twHintImg', __("Define image for Twitter counter tooltip", SC_DOMAIN), array(&$this, 'drawTextOption'), 'simple-counters', 'sc_hints_section', array('width' => '100%', 'description' => __("This is image for Twitter tooltip (Full URL). 40x40 pixels, transparent background PNG image recommended.", SC_DOMAIN)));
      add_settings_field('twHintImgSource', __('Define image source for Twitter counter tooltip', SC_DOMAIN), array(&$this, 'drawRadioOption'), 'simple-counters', 'sc_hints_section', array("options" => array( 'user' => __("User defined", SC_DOMAIN), 'avatar' => __("Twitter avatar", SC_DOMAIN)), 'description' => __('Selecting "User defined" will set user defined image for Twitter counter tooltip, "Twitter avatar" will set your Twitter avatar as image for Twitter counter tooltip.', SC_DOMAIN)));
      
      register_setting('scOptions', SC_OPTIONS_NAME, array(&$this, 'sanitizeSettings'));
    }
    
    function sanitizeSettings($input) {
      if($input['requestPeriod'] !== $this->settings['requestPeriod']) {
        wp_clear_scheduled_hook('getCountersEvent');
        wp_schedule_event(time(), $input['requestPeriod'], 'getCountersEvent');
      }
      /*$output = $this->settings;
      foreach($input as $key => $option) {
        $output[$key] = $option;
      }
      $output = $this->getCounters(array('force' => false, 'settings' => $output));
      $this->settings = $output;*/
      //return $output;
      //$this->getCounters();
      return $input;
    }
    
    function drawAccountSection() {
      echo '<p>'.__('You must define IDs for both accounts, FeedBurner and Twitter, for properly work of plugin.', SC_DOMAIN).'</p>';
    }
    
    function drawBadgeSection() {
      echo '<p>'.__('Use parameters below for customising Simple Counters badge style.', SC_DOMAIN).'</p>';
    }
    
    function drawOutputSection() {
      echo '<p>'.__('Use parameters below for customising output data format.', SC_DOMAIN).'</p>';
    }
    
    function drawHintsSection() {
      echo '<p>'.__('Use parameters below for customising Simple Counters tooltips.', SC_DOMAIN).'</p>';
    }
    
    function drawTechSection() {
      echo '<p>'.__('Use parameters below for customising technical parameters of Simple Counters.', SC_DOMAIN).'</p>';
    }
    
    public function drawSelectOption( $id, $args ) {
      $options = $args['options'];
      ?>
        <select id="<?php echo $id; ?>"
          name="<?php echo SC_OPTIONS_NAME.'['.$id.']'; ?>">
          <?php foreach($options as $key => $option) { ?>
            <option value="<?php echo $key; ?>" 
              <?php selected($key, $this->settings[$id]); ?> ><?php echo $option; ?>
            </option>
          <?php } ?>
        </select>
      <?php
    }
    
    public function drawRadioOption( $id, $args ) {
      $options = $args['options'];
      $labelId = $args['labelId'];
      foreach ($options as $key => $option) {
      ?>
        <input type="radio" 
          id="<?php echo $id.'_'.$key; ?>" 
          name="<?php echo SC_OPTIONS_NAME.'['.$id.']'; ?>" 
          value="<?php echo $key; ?>" <?php checked($key, $this->settings[$id]); ?> />
        <label <?php if($labelId) echo 'id="lb_'.$id.'_'.$key.'"'; ?> for="<?php echo $id.'_'.$key; ?>"> 
          <?php echo $option;?>
        </label>&nbsp;&nbsp;&nbsp;&nbsp;
      <?php
      if($args['style'] === 'vertical') echo '<br/>';
      }
    }
    
    public function drawTextOption( $id, $args ) {
      $width = $args['width'];
      ?>
        <input id="<?php echo $id; ?>"
          name="<?php echo SC_OPTIONS_NAME.'['.$id.']'; ?>"
          type="text"
          value="<?php echo $this->settings[$id]; ?>" 
          style="height: 22px; font-size: 11px; <?php if(!empty($width)) echo 'width: '.$width.';' ?>" />
      <?php
    }

    public function drawCheckboxOption( $id, $args ) {
      ?>
        <input id="<?php echo $id; ?>"
          <?php checked('true', $this->settings[$id]); ?>
          name="<?php echo SC_OPTIONS_NAME.'['.$id.']'; ?>"
          type="checkbox"
          value="true" />
      <?php
    }
    
    public function drawCheckGroupOption( $id, $args ) {
      $options = $args['options'];
      foreach($options as $key => $option) {
      ?>
        <input id="<?php echo $key; ?>"
          <?php checked('true', $this->settings[$key]); ?>
          name="<?php echo SC_OPTIONS_NAME.'['.$key.']'; ?>"
          type="checkbox"
          value="true" />
        <label for='<?php echo $key; ?>'>
          <?php echo $option ?>
        </label>&nbsp;&nbsp;&nbsp;&nbsp;
      <?php
      if($args['style'] === 'vertical') echo '<br/>';
      }
    }
    
    function drawInfo( $id, $args ) {
      $options = $args['options'];
      foreach($options as $option) {
        if($option === 'feedburner') {
          $data = $this->getFbCount();
          $count = $data['circulation'];
          $cid = 'fbCount';
        }
        elseif($option === 'twitter') {
          $data = $this->getTwCount();
          $count = $data['followers'];
          $cid = 'twCount';
        }
        ?>
          <input id='<?php echo $cid; ?>'
            type='hidden' 
            name='<?php echo SC_OPTIONS_NAME.'['.$cid.']'; ?>'  
            value='<?php echo $count; ?>'>
        <?php 
        echo $this->doInfo($option, $count).'<br/>';
      }
    }
    
    function drawCount( $id, $args ) {
      if($args['count'] === 'feedburner') {
        $data = $this->getFbCount();
        $count = $data['circulation'];
      }
      elseif($args['count'] === 'twitter') {
        $data = $this->getTwCount();
        $count = $data['followers'];
      }
      ?>
        <input id='<?php echo $id; ?>'
          type='hidden' 
          name='<?php echo SC_OPTIONS_NAME.'['.$id.']'; ?>'  
          value='<?php echo $count; ?>'><?php echo $count; ?>
      <?php 
    }
    
    function doSettingsSections($page) {
      global $wp_settings_sections, $wp_settings_fields;

      if ( !isset($wp_settings_sections) || !isset($wp_settings_sections[$page]) )
        return;

      foreach ( (array) $wp_settings_sections[$page] as $section ) {
        switch($section['id']) {
          case 'sc_account_section':
            echo "<div id='tab-general'>";
            break;
          case 'sc_badge_section':
            echo "<div id='tab-badge'>";
            break;
          case 'sc_hints_section':
            echo "<div id='tab-hints'>";
            break;
          default: break;
        }
        
        echo "<div id='poststuff' class='ui-sortable'>\n";
        echo "<div class='postbox opened'>\n";
        echo "<h3>{$section['title']}</h3>\n";
        echo '<div class="inside">';
        call_user_func($section['callback'], $section);
        if ( !isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section['id']]) )
          continue;
        $this->doSettingsFields($page, $section['id']);
        echo '</div>';
        echo '</div>';
        echo '</div>';
        
        switch($section['id']) {
          case 'sc_tech_section':
            echo "</div>";
            break;
          case 'sc_badge_section':
            echo "</div>";
            break;
          case 'sc_hints_section':
            echo "</div>";
            break;
          default: break;
        }
      }
    }
    
    function doSettingsFields($page, $section) {
      global $wp_settings_fields;

      if ( !isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section]) )
        return;

      foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
        echo '<p>';
        if ( !empty($field['args']['checkbox']) ) {
          call_user_func($field['callback'], $field['id'], $field['args']);
          echo '<label for="' . $field['args']['label_for'] . '">' . $field['title'] . '</label>';
          echo '</p>';
        }
        else {
          if ( !empty($field['args']['label_for']) )
            echo '<label for="' . $field['args']['label_for'] . '">' . $field['title'] . '</label>';
          else
            echo '<strong>' . $field['title'] . '</strong><br/>';
          echo '</p>';
          echo '<p>';
          call_user_func($field['callback'], $field['id'], $field['args']);
          echo '</p>';
        }
        if(!empty($field['args']['description'])) echo '<p>' . $field['args']['description'] . '</p>';
      }
    }
    
    function onAdminPage() {
      if (function_exists('add_options_page')) {
        $plugin_page = add_options_page(__('Simple Counters', SC_DOMAIN), __('Simple Counters', SC_DOMAIN), 8, SC_DOMAIN, array(&$this, 'drawAdminPage'));
        add_action('admin_print_styles-'.$plugin_page, array(&$this, 'adminHeaderStyles'));
        add_action('admin_print_scripts-'.$plugin_page, array(&$this, 'adminHeaderScripts'));
      }
    }
    
    function drawAdminPage() {
      $mem = ini_get('memory_limit');
      $version = $this->getEngineVersion();
      $wpVersion = $version['str'];
      ?>
      <div class="wrap">
        <?php screen_icon("options-general"); ?>
        <h2><?php  _e("Simple Counters Settings", SC_DOMAIN); ?></h2>
        <?php
        if(isset($_GET['settings-updated'])) $updated = $_GET['settings-updated'];
        elseif(isset($_GET['updated'])) $updated = $_GET['updated'];
        if($updated === 'true') {
          //$this->getCounters();
          //$this->settings = parent::getOptions();
        }
        ?>
        <div class="clear"></div>
        <form action="options.php" method="post">
          <div id='poststuff' class='metabox-holder has-right-sidebar'>
            <div id="side-info-column" class="inner-sidebar" style='width: 281px !important;'>
              <div class='postbox opened'>
                <h3><?php _e('System Info', SAM_DOMAIN) ?></h3>
                <div class="inside">
                  <p>
                    <?php 
                      echo __('Wordpress Version', SC_DOMAIN).': <strong>'.$wpVersion.'</strong><br/>';
                      echo __('Plugin Version', SC_DOMAIN).': <strong>'.SC_VERSION.'</strong><br/>';
                      echo __('PHP Version', SC_DOMAIN).': <strong>'.PHP_VERSION.'</strong><br/>';
                      echo __('Memory Limit', SC_DOMAIN).': <strong>'.$mem.'</strong>'; 
                    ?>
                  </p>
                  <p>
                    <?php _e('Note! If you have detected a bug, include this data to bug report.', SAM_DOMAIN); ?>
                  </p>
                </div>
              </div>
              <div class='postbox opened'>
                <h3><?php _e('Resources', SC_DOMAIN) ?></h3>
                <div class="inside">
                  <ul>
                    <li><a target='_blank' href='http://wordpress.org/extend/plugins/simple-counters/'><?php _e("Wordpress Plugin Page", SC_DOMAIN); ?></a></li>
                    <li><a target='_blank' href='http://www.simplelib.com/?p=256'><?php _e("Author Plugin Page", SC_DOMAIN); ?></a></li>
                    <li><a target='_blank' href='http://forum.simplelib.com/forumdisplay.php?10-Simple-Counters/'><?php _e("Support Forum", SC_DOMAIN); ?></a></li>
                    <li><a target='_blank' href='http://www.simplelib.com/'><?php _e("Author's Blog", SC_DOMAIN); ?></a></li>
                  </ul>                    
                </div>
              </div>  
              <div class='postbox opened'>
                <h3><?php _e('Donations', SC_DOMAIN) ?></h3>
                <div class="inside">
                  <p>
                    <?php 
                      $format = __('If you have found this plugin useful, please consider making a %s to help support future development. Your support will be much appreciated. Thank you!', SC_DOMAIN);
                      $str = '<a title="'.__('Donate Now!', SC_DOMAIN).'" href="https://load.payoneer.com/LoadToPage.aspx?email=minimus@simplelib.com" target="_blank">'.__('donation', SC_DOMAIN).'</a>';
                      printf($format, $str); 
                    ?>
                  </p>
                  <center>
                    <a title="Donate Now!" href="https://load.payoneer.com/LoadToPage.aspx?email=minimus@simplelib.com" target="_blank">
                      <img  title="<?php _e('Donate Now!', SC_DOMAIN); ?>" src="<?php echo SC_IMG_URL.'donate-now.png' ?>" alt="" width="100" height="34" style='margin-right: 5px;' />
                    </a>
                  </center>
                  <p style='margin: 3px; font-size: 0.8em !important;'>
                    <?php 
                      $format = __("Warning! The default value of donation is %s. Don't worry! This is not my appetite, this is default value defined by Payoneer service.", SC_DOMAIN).'<strong>'.__(' You can change it to any value you want!', SC_DOMAIN).'</strong>';
                      $str = '<strong>$200</strong>';
                      printf($format, $str);
                    ?>
                  </p>                    
                </div>
              </div>
            </div>
            <div id="post-body">
              <div id="post-body-content">
                <div id='tabs'>
                  <ul>
                    <li><a href='#tab-general'><?php _e('General', SC_DOMAIN); ?></a></li>
                    <li><a href='#tab-badge'><?php _e('Badge', SC_DOMAIN); ?></a></li>
                    <li><a href='#tab-hints'><?php _e('Tooltips', SC_DOMAIN); ?></a></li>
                  </ul>
                  <?php settings_fields('scOptions'); ?>
                  <?php $this->doSettingsSections('simple-counters'); ?>
                </div>
                <img id='feed-uri-img' src='<?php echo SC_IMG_URL.'feed-uri.jpg' ?>' alt='FeedBurner URI' style='display: none;'/>
                <img id='awareness-img' src='<?php echo SC_IMG_URL.'awareness.jpg' ?>' alt='Awareness API' style='display: none;'/>
                <img id='win7-img' src='<?php echo SC_IMG_URL.'win7.jpg' ?>' alt='WindowZ Aero' style='display: none;'/>
                <img id='std-img' src='<?php echo SC_IMG_URL.'std.jpg' ?>' alt='Default' style='display: none;'/>
                <p class="submit">
                  <input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
                </p>
                <p style='color: #777777; font-size: 12px; font-style: italic;'>Simple Counters plugin for Wordpress. Copyright &copy; 2010 - 2011, <a href='http://www.simplelib.com/'>minimus</a>. All rights reserved.</p>
              </div>
            </div>
          </div>
        </form>
      </div>
      <?php
    }
  }
}
?>
