<?php
if(!class_exists('SimpleCounters')) {
  class SimpleCounters {
    public $settings;
    public $adminOptionsName = "SimpleCountersAdminOptions";
    public $scInitOptions = array(
      // Id options
      fbId            => '',
      twId            => '',
      fontColor        => 'ffffff',
      color           => '1c82d0',
      colorTo         => '145181',
      borderColor     => '676767',
      borderStyle     => 'win7',
      position        => 'right',
      delta           => '0',
      gradient        => 'vertical',
      fbImg           => '',
      twImg           => '',
      fbHint          => '',
      twHint          => '',
      fbCount          => '',
      twCount          => '',
      hints            => 'themed',
      fbHintImg        => '',
      twHintImg        => '',
      twHintImgSource  => 'user',
      twAvatar        => '',
      hintTheme        => 'custom',
      hintFontColor    => 'ffffff',
      hintFontSize    => '12',
      hintColor        => '1c82d0',
      hintBorderColor => '145181',
      requestTimeOut  => '10',
      requestPeriod    => 'twicedaily', // hourly|twicedaily|daily
      lastUpdated      => '',
      fbErrorCode      => '',
      twErrorCode      => '',
      errorAction      => 'previous',
      templBold        => 'true',
      templItalic      => 'false',
      fbSubData        => 'default', // default|xml
      fbStr           => 'readers',
      twStr           => 'followers',
      version          => '1.0.15'
    );
    
    function __construct() {
      define('SC_PATH', dirname( SC_MAIN_FILE ));
      define('SC_DOMAIN', 'simple-counters');
      define('SC_OPTIONS_NAME', "SimpleCountersAdminOptions");
      define('SC_VERSION', '1.0.15');
      define('SC_URL', WP_PLUGIN_URL . '/' . str_replace( basename( __FILE__), "", plugin_basename( __FILE__ ) ));
      define('SC_IMG_URL', SC_URL.'images/');
      
      //$plugin_dir = basename(dirname(__FILE__));
      if (function_exists( 'load_plugin_textdomain' ))
        load_plugin_textdomain( SC_DOMAIN, false, basename( SC_PATH ) );
      $scOptions = $this->getOptions();
      add_action('activate_simple-counters/simple-counters.php',  array(&$this, 'onActivate'));
      add_action('deactivate_simple-counters/simple-counters.php',  array(&$this, 'onDeactivate'));
      if(($scOptions['fbId'] !== '') && ($scOptions['twId'] !== '')) {
        add_action('wp_head', array(&$this, 'headerStyles'), 1);
        add_action('template_redirect', array(&$this, 'headerScripts'));
      }
      add_action('getCountersEvent', array(&$this, 'getCounters'));
      $this->settings = $scOptions;
    }
    
    function onActivate() {
      $scAdminOptions = $this->getOptions();
      update_option($this->adminOptionsName, $scAdminOptions);
      wp_schedule_event(time(), $scAdminOptions['requestPeriod'], 'getCountersEvent');
    }
    
    function onDeactivate() {
      wp_clear_scheduled_hook('getCountersEvent');
      delete_option(SC_OPTIONS_NAME);
    }
    
    /*function browser_info($agent=null) {
      $known = array('msie', 'firefox', 'safari', 'webkit', 'opera', 'netscape', 'konqueror', 'gecko');

      $agent = strtolower($agent ? $agent : $_SERVER['HTTP_USER_AGENT']);
      $pattern = '#(?<browser>' . join('|', $known) . ')[/ ]+(?<version>[0-9]+(?:\.[0-9]+)?)#';

      if (!preg_match_all($pattern, $agent, $matches)) return array();

      $i = count($matches['browser'])-1;
      return array($matches['browser'][$i] => $matches['version'][$i]);
    }*/
    
    public function getEngineVersion() {
      global $wp_version;
      $version = array();
      
      $ver = explode('.', $wp_version);
      $version['major'] = $ver[0];
      $vc = count($ver);
      if($vc == 2) {
        $subver = explode('-', $ver[1]);
        $version['minor'] = $subver[0];
        $version['spec'] = $subver[1];
        $version['str'] = $version['major'].'.'.$version['minor'].((!empty($version['spec'])) ? ' ('.$version['spec'].')' : '');
      }
      else {
        $version['minor'] = $ver[1];
        $version['build'] = $ver[2];
        $version['str'] = $wp_version;
      }
      
      
      return $version;
    }
    
    function getOptions() {
      $scAdminOptions = $this->scInitOptions;
      $scOptions = get_option($this->adminOptionsName);
      if (!empty($scOptions)) {
        foreach ($scOptions as $key => $option) {
          $scAdminOptions[$key] = $option;
        }
      }      
      if($scAdminOptions['fbImg'] === '') $scAdminOptions['fbImg'] = WP_PLUGIN_URL.'/simple-counters/images/feedburner.png';
      if($scAdminOptions['twImg'] === '') $scAdminOptions['twImg'] = WP_PLUGIN_URL.'/simple-counters/images/twitter.png';
      if($scAdminOptions['fbHintImg'] === '') $scAdminOptions['fbHintImg'] = WP_PLUGIN_URL.'/simple-counters/images/feedburner-hint.png';
      if($scAdminOptions['twHintImg'] === '') $scAdminOptions['twHintImg'] = WP_PLUGIN_URL.'/simple-counters/images/twitter-hint.png';
      if($scAdminOptions['fbHint'] === '')
        $scAdminOptions['fbHint'] = __('Subscribe to', SC_DOMAIN).' [blog_name] '.__('to receive breaking news as well as receive other site updates!', SC_DOMAIN);
      if($scAdminOptions['twHint'] === '') 
        $scAdminOptions['twHint'] = __('Share and discover what is happening right now, at the', SC_DOMAIN).' [blog_name]!<br/>'.__('Follow Me on Twitter!', SC_DOMAIN);
       if($scAdminOptions['version'] !== $this->scInitOptions['version']) $scAdminOptions['version'] = $this->scInitOptions['version'];
      if($scAdminOptions['fbStr'] !== '') $scAdminOptions['fbStr'] = _n('reader', 'readers', $scAdminOptions['fbCount'], SC_DOMAIN);
      if($scAdminOptions['fbStr'] !== '') $scAdminOptions['twStr'] = _n('follower', 'followers', $scAdminOptions['twCount'], SC_DOMAIN);
      return $scAdminOptions;
    }
    
    function headerStyles() {
      $options = $this->settings;
      wp_enqueue_style('qtip', WP_PLUGIN_URL.'/simple-counters/css/jquery.qtip.css', false, '2.0.0');
      if($options['hintTheme'] === 'custom') echo
        "<style>"."\n". 
        ".ui-tooltip-custom .ui-tooltip-titlebar, .ui-tooltip-custom .ui-tooltip-content{"."\n".
        "  border-color: #".$options['hintBorderColor']." !important;"."\n".
        "  color: #".$options['hintFontColor']." !important;"."\n".
        "}"."\n\n".
        ".ui-tooltip-custom .ui-tooltip-content{"."\n".
        "   background-color: #".$options['hintColor']." !important;"."\n".
        "}"."\n\n".
        ".ui-tooltip-custom .ui-tooltip-titlebar{"."\n".
        "   background-color: #".$options['hintColor']." !important;"."\n".
        "}"."\n".
        "</style>"."\n";
    }
    
    function headerScripts() {
      global $is_IE;
      $options = $this->settings;
      $wv = $this->getEngineVersion();
      $wp33plus = false;
      if((int)$wv['major'] == 3 && (int)$wv['minor'] >= 3) $wp33plus = true;
      if((int)$wv['major'] > 3) $wp33plus = true;
      
      $options['fbHint'] = self::parseKeywords($options['fbHint']);
      $options['twHint'] = self::parseKeywords($options['twHint']);
      
      $style = 'ui-tooltip-' . $options['hintTheme'];
      
      $scOptions = array(
        'position' =>  $options['position'],
        'delta' => $options['delta'],
        'fontColor' => '#' . $options['fontColor'],
        'color' => '#' . $options['color'],
        'colorTo' => '#' . $options['colorTo'],
        'borderColor' => '#' . $options['borderColor'],
        'borderStyle' => $options['borderStyle'],
        'dgv' =>  $options['gradient'],
        'hints' =>  $options['hints'],
        'feedBurner' => array(
          'id' =>  $options['fbId'],
          'imgUrl' =>  $options['fbImg'],
          'count' =>  $options['fbCount'],
          'hint' =>  $this->parseKeywords( $options['fbHint'] ),
          'hintImg' =>  $options['fbHintImg'],
          'subData' =>  $options['fbSubData'],
          'str' => $options['fbStr']
        ),
        'twitter' => array(
          'id' =>  $options['twId'],
          'imgUrl' =>  $options['twImg'],
          'count' =>  $options['twCount'],
          'hint' =>  $this->parseKeywords( $options['twHint'] ),
          'hintImg' =>  ( (($options['twHintImgSource'] === 'avatar') && ($options['twAvatar'] !== '')) ? $options['twAvatar'] : $options['twHintImg'] ),
          'useAvatar' => (($options['twHintImgSource'] === 'avatar') ? 'true' : 'false'),
          'str' => $options['twStr']
        ),
        'hintStyle' => $style
      );
            
      wp_register_script('excanvas', WP_PLUGIN_URL.'/simple-counters/js/excanvas.js');
      wp_enqueue_script('jquery');
      if($is_IE) wp_enqueue_script('excanvas');
      wp_enqueue_script('qTip', WP_PLUGIN_URL.'/simple-counters/js/jquery.qtip.js', array('jquery'), '2.0.0');
      wp_enqueue_script('simpleCounters', WP_PLUGIN_URL.'/simple-counters/js/sc.js', array('jquery', 'qTip'), $this->scInitOptions['version']);
      if($wp33plus) wp_localize_script('simpleCounters', 'scOptions', $scOptions);
      else wp_localize_script('simpleCounters', 'scOptions', array('l10n_print_after' => 'scOptions = ' . json_encode($scOptions) . ';'));
    }
    
    function getFbCount() {
      $options = $this->settings;
      $fbUrl = 'http://feedburner.google.com/api/awareness/1.0/GetFeedData?uri=' . $options['fbId'];
      $circulation = 0;
      $timeout = intval($options['requestTimeOut']);
      $errorCode = '';
    
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
      curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3');
      curl_setopt($ch, CURLOPT_URL, $fbUrl);
      $xml = curl_exec($ch);
      $info = curl_getinfo($ch);
    
      curl_close($ch);
    
      $http_code = $info['http_code'];
      
      if ($http_code == 200) {
        $rsp = new SimpleXMLElement($xml);
        $circulation = $rsp->feed[0]->entry['circulation'];
        settype($circulation, 'string');
      }
      else {
        switch($options['errorAction']){
          case 'error':
            $circulation = 'E:' . $http_code;
            break;
          
          case 'previous':
            $circulation = $options['fbCount'];
            break;
            
          case 'client':
            $circulation = '-1';
            break;
        }
        $errorCode = $http_code;
      }
            
      return array( 'circulation' => $circulation, 'errorCode' => $errorCode );
    }
    
    function getTwCount() {
      $options = $this->settings;
      $twUrl = 'http://twitter.com/users/show.xml?screen_name=' . $options['twId'];
      $followers = 0;
      $timeout = intval($options['requestTimeOut']);
      $errorCode = '';
      $avatar = '';
      
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
      curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3');
      curl_setopt($ch, CURLOPT_URL, $twUrl);
      $xml = curl_exec($ch);
      $info = curl_getinfo($ch);
    
      curl_close($ch);
    
      $http_code = $info['http_code'];
      
      if ($http_code == 200) {
        $user = new SimpleXMLElement($xml);
        $followers = (string) $user->followers_count;
        $avatar = (string) $user->profile_image_url;
      }
      else {
        switch ($options['errorAction']) {
          case 'error':
            $followers = 'E:' . $http_code;
            break;
            
          case 'previous':
            $followers = $options['twCount'];
            break;
            
          case 'client':
            $followers = '-1';
            break;
        }
        $errorCode = $http_code;
        $avatar = '';        
      }
      
      return array( 'followers' => $followers, 'errorCode' => $errorCode, 'avatar' => $avatar );
    }
    
    function mustSet($value, $option) {
      $result = TRUE;
      if( $value === '' ) $result = FALSE;
      elseif( $value === $option ) $result = FALSE;
      elseif(( $value === '0' ) && ( intval($option) > 0 )) $result = FALSE;
      return $result;
    }
    
    function getCounters( $args = null ) {
      /*$options = array();*/
      $force = true;
      /*if(is_array($args)) {
        if(!empty($args['force'])) $force = $args['force'];
        else $force = true;
        if(!empty($args['settings']) && is_array($args['settings'])) $options = $args['settings'];
        else $options = $this->settings;
      }
      else {
        $force = true;*/
        $options = $this->settings;
      //}
      if(($options['fbId'] !== '') && ($options['twId'] !== '')) {
        $feedBurner = $this->getFbCount();
        $twitter = $this->getTwCount();
        if($this->mustSet($feedBurner['circulation'], $options['fbCount'])) {
          $options['fbCount'] = $feedBurner['circulation'];
          $options['fbErrorCode'] = $feedBurner['errorCode'];
        }
        if($this->mustSet($twitter['followers'], $options['twCount'])) {
          $options['twCount'] = $twitter['followers'];
          $options['twErrorCode'] = $twitter['errorCode'];
        }
        $options['twAvatar'] = $twitter['avatar'];
        $options['lastUpdated'] = time();
        if($options['fbStr'] !== '') $options['fbStr'] = _n('reader', 'readers', $options['fbCount'], SC_DOMAIN);
        if($options['fbStr'] !== '') $options['twStr'] = _n('follower', 'followers', $options['twCount'], SC_DOMAIN);
        if($force) update_option(SC_OPTIONS_NAME, $options);
        return $options;
      }
    }
    
    function parseKeywords($text) {
      $scOptions = $this->settings;
      $style = array('bold' => ($scOptions['templBold'] === 'true'), 'italic' => ($scOptions['templItalic'] === 'true'));
      $blogName = get_bloginfo('name');
      $twNick = $scOptions['twId'];
      
      if($style['italic']) {
        $blogName = '<em>'.$blogName.'</em>';
        $twNick = '<em>'.$twNick.'</em>';
      }
      if($style['bold']) {
        $blogName = '<strong>'.$blogName.'</strong>';
        $twNick = '<strong>'.$twNick.'</strong>';
      }
      
      $text = str_replace('[blog_name]', $blogName, $text);
      $text = str_replace('[twitter_nick]', $twNick, $text);
      
      return $text;
    }    
  } // End of class
} //End of If
?>
